#ifndef GSMP_FIND_MEM_CORRUPTION_HH
#define GSMP_FIND_MEM_CORRUPTION_HH

#include <iostream>
#include <string> 

#define ANTI_CORRUPTION_BUDGET 0x10

class FindMemCorruption
{
public:
  FindMemCorruption (string i_comment)
  {
    m_comment = i_comment;

    cout << m_comment << " becomes valid" << endl;

    for (int i = 0; i < ANTI_CORRUPTION_BUDGET; i++)
      fakemem [i] = 0x23;
  }

  void Check4Corruption ()
  {
    cout << m_comment << " Checking...." << endl;

    for (int i = 0; i < ANTI_CORRUPTION_BUDGET; i++)
      if (fakemem [i] != 0x23)
	cout << m_comment << " CORRUPTED DATA !!!!! OFFSET: " << i << endl;

    cout << m_comment << " done. " << endl;
  }

  ~FindMemCorruption ()
  {
    cout << m_comment << " becomes invalid. " << endl;
  }

private:
  char fakemem [ANTI_CORRUPTION_BUDGET];
  string m_comment;
};

#endif // GSMP_FIND_MEM_CORRUPTION_HH
